unit fdm;

{$mode ObjFPC}{$H+}

interface

uses
  Classes, SysUtils, SQLDB, DB, ZConnection, ZDataset, ZSqlUpdate,
  ZAbstractRODataset, ZSequence, Graphics, Dialogs;

type

  { TDM }

  TDM = class(TDataModule)
    DSTDocus: TDataSource;
    DSDDocus: TDataSource;
    DSMDocus: TDataSource;
    ZCDoc: TZConnection;
    ZQDDocusdatetest: TZDateField;
    ZQDDocusdocument: TZInt64Field;
    ZQDDocusimage: TZBlobField;
    ZQDDocusmodel: TZRawStringField;
    ZQDDocusNotas: TZRawCLobField;
    ZQDDocusserie: TZRawStringField;
    ZQDDocustestfol: TZDoubleField;
    ZQDDocustestpass: TZBooleanField;
    ZQMDoc: TZQuery;
    ZQMDocModel: TZRawStringField;
    ZQMDocserie: TZRawStringField;
    ZQDDocus: TZQuery;
    ZSDoc: TZSequence;
    ZTDocs: TZTable;
    ZTCon: TZTransaction;
    ZUDocus: TZUpdateSQL;
    ZUDDcus: TZUpdateSQL;
    procedure DataModuleCreate(Sender: TObject);
    procedure ZQMDocAfterDelete(DataSet: TDataSet);
    procedure ZQMDocAfterEdit(DataSet: TDataSet);
    procedure ZQMDocAfterPost(DataSet: TDataSet);

    procedure ZQMDocBeforeInsert(DataSet: TDataSet);
    procedure ZQMDocBeforePost(DataSet: TDataSet);
    procedure ZQMDocEditError(DataSet: TDataSet; E: EDatabaseError;
      var DataAction: TDataAction);
    procedure ZQMDocNewRecord(DataSet: TDataSet);
    procedure ZQMDocPostError(DataSet: TDataSet; E: EDatabaseError;
      var DataAction: TDataAction);
    procedure ZTDocsBeforePost(DataSet: TDataSet);
  private

  public

  end;

var
  DM: TDM;

implementation
  uses variants;
{$R *.frm}

{ TDM }

procedure TDM.DataModuleCreate(Sender: TObject);
begin
  ZCDoc.Database:= GetCurrentDir+'\Datas\DocuControl.db' ;
  ZCDoc.LibraryLocation:=GetCurrentDir+'\sqlite3.dll' ;
  try
    ZCDoc.Connect;

  except on e:Exception do
     ShowMessage(E.Message);
  end;
end;

procedure TDM.ZQMDocAfterDelete(DataSet: TDataSet);
begin

end;

procedure TDM.ZQMDocAfterEdit(DataSet: TDataSet);
begin

end;

procedure TDM.ZQMDocAfterPost(DataSet: TDataSet);
begin
  try
    ZQMDoc.ApplyUpdates();
    ZTCon.Commit;
    ShowMessage('Record update succeeded!');
  except
     ZTCon.Rollback;
    ShowMessage('Record update failed!');
  end;
end;



procedure TDM.ZQMDocBeforeInsert(DataSet: TDataSet);
  Var bm:TBookmark;
    Modl,ser:String;
  begin
    bm:=DataSet.Bookmark;
    Modl:= Dataset.FieldByName('Model').AsString;
    Ser:= DataSet.FieldByName('serie').AsString ;
    if( ZQMDoc.Locate('model ; serie', VarArrayOf([Modl ,Ser ]), [loCaseInsensitive,loPartialKey]) ) then begin
       Showmessage('Before Insert  Register with values already exist');
       ZQMDoc.Cancel;
    end else begin
       ZQMDoc.Post;
       ZQMDoc.GotoBookmark(bm);
    end;

end;

procedure TDM.ZQMDocBeforePost(DataSet: TDataSet);
Var bm:TBookmark;
  Modl,ser:String;
begin
  bm:=DataSet.Bookmark;
  Modl:= Dataset.FieldByName('Model').AsString;
  Ser:= DataSet.FieldByName('serie').AsString ;
  if( ZQMDoc.Locate('model ; serie', VarArrayOf([Modl ,Ser ]), [loCaseInsensitive,loPartialKey]) ) then begin
     Showmessage('Before Post Reister with values already exist');
     ZQMDoc.Cancel;
  end else begin
     ZQMDoc.Post;
     ZQMDoc.GotoBookmark(bm);
  end;
end;

procedure TDM.ZQMDocEditError(DataSet: TDataSet; E: EDatabaseError;
  var DataAction: TDataAction);
begin

end;

procedure TDM.ZQMDocNewRecord(DataSet: TDataSet);
begin
  ZQMDoc.FieldByName('model').AsString:='';
  ZQMDoc.FieldByName('serie').AsString:='';
end;

procedure TDM.ZQMDocPostError(DataSet: TDataSet; E: EDatabaseError;
  var DataAction: TDataAction);
begin
//   ShowMessage('Error ' + E.Message );
//  DataSet.Cancel;
end;

procedure TDM.ZTDocsBeforePost(DataSet: TDataSet);
begin
  if( ZTDocs.State= dsEdit) then begin
     if( not  ZTDocs.Locate('model ; serie', VarArrayOf([DM.ZTDocs.FieldByName('model').AsString ,DM.ZTDocs.FieldByName('serie').AsString ]), [loCaseInsensitive,loPartialKey]))  then begin
        ShowMessage('Register with this values already registered');
     end;
  end;

end;

end.

